`timescale 1ps/1ps

module testbench;

reg SYSCLK_P, SYSCLK_N, GPIO_DIP_SW0, GPIO_SW_N;
wire PMOD1_0_LS, PMOD1_1_LS, PMOD1_2_LS, PMOD1_3_LS, PMOD2_0_LS, PMOD2_1_LS, PMOD2_2_LS, PMOD2_3_LS;

CM0_DSSystem DUT
(
.PMOD1_0_LS(PMOD1_0_LS),
.PMOD1_1_LS(PMOD1_0_LS),
.PMOD1_2_LS(PMOD1_0_LS),
.PMOD1_3_LS(PMOD1_0_LS),
.PMOD2_0_LS(PMOD1_0_LS),
.PMOD2_1_LS(PMOD1_0_LS),
.PMOD2_2_LS(PMOD1_0_LS),
.PMOD2_3_LS(PMOD1_0_LS),
.SYSCLK_P (SYSCLK_P),
.SYSCLK_N (SYSCLK_N),
.GPIO_DIP_SW0(GPIO_DIP_SW0),
.GPIO_SW_N(GPIO_SW_N)
);

initial
begin
SYSCLK_P=1;
SYSCLK_N=0;

forever 
begin
#2500
SYSCLK_P=~SYSCLK_P;
SYSCLK_N=~SYSCLK_N; // clk period 5ns 200 MHz
end
end

initial
begin
GPIO_DIP_SW0=1;//global enable
GPIO_SW_N=0;//reset
#2202000 //2.2 us
GPIO_SW_N=1;
#220000 //2.2 us
GPIO_SW_N=0;
#200000000 //200 us
GPIO_SW_N=1;
/*#2200000
GPIO_DIP_SW0=0;*/
#220000
GPIO_SW_N=0;
end

endmodule