import sys
#import math
import csv

# Power tables uA/MHz
readpwrs = {}
writepwrs = {}
flashpwr = 180

readpwrs[128] = 15
writepwrs[128] = 20
readpwrs[256] = 17
writepwrs[256] = 24
readpwrs[384] = 19
writepwrs[384] = 28
readpwrs[512] = 21
writepwrs[512] = 30
readpwrs[640] = 23
writepwrs[640] = 34
readpwrs[768] = 25
writepwrs[768] = 37
readpwrs[896] = 27
writepwrs[896] = 41
readpwrs[1024] = 28
writepwrs[1024] = 44
readpwrs[1536] = 35
writepwrs[1536] = 42
readpwrs[2048] = 37
writepwrs[2048] = 46
readpwrs[4096] = 37
writepwrs[4096] = 46


dataset='dijkstra.csv';
sram_writes=0
sram_reads=0
flash_reads=0
old_old=0
old=0
new=0
size=0
dummy=0
flag=0
loops=0
first=0
sbb=0
loop_size=0
loop_sz=[]
times_ex=[]
sbbs=[]
firsts=[]
inst_no=[]
invalid=0
power_nocache=0.0
power_withcache=0.0
position=1
power_savings = 0.0
x=0.0
sbb_temp=0
sacekaj=0
try:
  file = open(dataset,'r')
  print 'Dataset successfully opened!'
except:
  print 'Could not open dataset'
  sys.exit()


file.readline()   # Ignore first line
instruction=0
for line in file.xreadlines():
  position=position+1
# Split out the address, ignore time for now
  try:
    addrhex = line.split(',')[1]
    timeString = line.split(',')[0]
  except:
    print 'Bad: ',
    print line
    continue
  try:      
    addr = int(addrhex, 16)
  except:
    print 'Could not convert %s to int' % addrhex
    continue
  
  if (addr == 0) or (addr > 4294967295):   # zasto je adresa 0 nevazeca? 
      invalid=invalid+1
      continue
  else:
      instruction=instruction+1
      if (instruction==1):   # prva instrukcija koja se ucitava
          flash_reads=flash_reads+1
          old_old=addr
          old=addr
          new=addr
          idle=1
          fill=0
          active=0
          sbb=0
          jump=0
      else:
          old_old=old
          old=new
          new=addr
          if (position==2451):
              sacekaj=1
          if (idle==1):   # IDLE STATE, dopustam samo jedan dummy skok da nista ne poremeti, znaci: 36 40 100 20 ide u FILL 40 20 24    40 20 10 takodje, e sad sta je PRAVI SBB u prvom i trecem  MOZDA COUNT STATE slucaju??????
              if (new==old_old+4):
                  old=old_old
                  flash_reads=flash_reads+1
                  if (sbb_temp!=0) and (new!=sbb_temp+4):
                      sbb=sbb_temp
                      first=old_old
                      fill=1
                      idle=0
                      sram_writes=sram_writes+2
                      flash_reads=flash_reads+1
                      sbb_temp=0
                      loop_size=2
                      continue
                  sbb_temp=0
                  continue
              if (new<old) and (old==old_old+4):   #   4*31=124
                  sbb_temp=old
                  flash_reads=flash_reads+1
                  continue
              if (new==old+4) and (old<old_old):
                  sram_reads=sram_reads+2
                  flash_reads=flash_reads+1
                  fill=1
                  idle=0
                  sbb=old_old
                  first=old
                  loop_size=2
                  sbb_temp=0
                  continue
              flash_reads=flash_reads+1
              sbb_temp=0
          else:    
              if (fill==1):  # FILL
#                       if (new==old+4) and (new==old_old+8):
#                           flash_reads=flash_reads+1
#                           sram_writes=sram_writes+1
#                           continue
#                       if (new==first) and (old==sbb):
#                           active=1
#                           fill=0
#                           sram_reads=sram_reads+1
#                           continue
#                       if (new!=old+4):
#                           if (jump==0):
#                               jump=1
#                               sbb_temp=old_old
#                               flash_reads=flash_reads+1
#                           else:
#                               if (new==first) and (old_old==sbb):
#                                  active=1
#                                  fill=0
#                                  sram_reads=sram_reads+1
#                                  jump=0
#                                  old=old_old
#                                  continue                                   
#                               if (new==old+4):
#                                   idle=1
#                                   fill=0
#                                   flash_reads=flash_reads+1
#                                   jump=0
#                                   continue
#                               if (new==old_old+4):
#                                  old=old_old
#                                  sram_writes=sram_writes+1
#                                  jump=0
#                                  continue
#                               idle=1
#                               fill=0
#                               flash_reads=flash_reads+1
                                   
                                                                                                   
                      if (new==first and old==sbb): #  FILL-> ACTIVE
                          sram_reads=sram_reads+1
                          active=1
                          fill=0
                          jump=0
                          times_executed=2
                      else:
                          if (new!=old+4):
                              if jump: # if there was a jump before this instruction, FILL -> IDLE
                                  flash_reads=flash_reads+1
                                  idle=1
                                  fill=0
                                  jump=0
                              else: #  if it is the first time we encounter a jumpL PSEUDO_FILL
                                  new=old                                  
                                  old=old_old
                                  jump=1
#                                  sbb_temp=old_old
                                  flash_reads=flash_reads+1
                          else:  #  regular FILL-> FILL
                          
                              jump=0
                              flash_reads=flash_reads+1
                              sram_writes=sram_writes+1
                              loop_size=loop_size+1
              else:
                  if (new==first and old==sbb): #  ACTIVE -> ACTIVE
                      sram_reads=sram_reads+1
                      jump=0
                      times_executed=times_executed+1
                  else:
                      if (new!=old+4):
                          if jump: # if there was a jump before this instruction, ACTIVE -> IDLE
                              flash_reads=flash_reads+1
                              idle=1
                              active=0
                              jump=0
                              loop_sz.append(loop_size)
                              times_ex.append(times_executed)
                              sbbs.append(sbb)
                              firsts.append(first)
                              inst_no.append(position)
                          else: #  if it is the first time we encounter a jump PSEUDO_ACTIVE                            
                              new=old
                              old=old_old
                              jump=1
                              flash_reads=flash_reads+1
                      else:  #  regular ACTIVE-> ACTIVE
                          jump=0
                          sram_reads=sram_reads+1
file.close()
print 'Sram Writes: %s' % sram_writes
print 'Sram Reads: %s' % sram_reads
print 'Flash Reads: %s' % flash_reads
print 'Valid Instructions: %s' % instruction
max_loop=max(loop_sz)
#max_loop=max_loop+4
#max_loop = max(loop_sz)
#index = loop_sz.index(max_loop)
#executions = times_ex[index]
#while (executions==0):
#    loop_sz[index]=0
#    max_loop = max(loop_sz)
#    index = loop_sz.index(max_loop)
#    executions = times_ex[index]
#
max_loop=max_loop*4

if (max_loop<=128):
    size=128
else: 
    if (max_loop<=256):
        size=256
    else:
        if (max_loop<=384):
            size=384
        else:
            if (max_loop<=512):
                size=512
            else:
                if (max_loop<=640):
                    size=640
                else:
                    if (max_loop<=768):
                        size=768
                    else:
                        if (max_loop<=896):
                            size=896
                        else:
                            if (max_loop<=1024):
                                size=1024
                            else:
                                if (max_loop<=1536):
                                    size=1536
                                else:
                                    if (max_loop<=2048):
                                        size=2048
                                    else:
                                        size=4096

                                            
                                            
power_nocache=(flash_reads+sram_reads)*flashpwr
power_withcache=flash_reads*flashpwr + sram_reads*readpwrs[size] + sram_writes*writepwrs[size]
hit_rate=sram_reads/float(sram_reads+flash_reads)
rw_ratio=sram_reads/float(sram_writes)
x=power_withcache/float(power_nocache)
power_savings = 1.0 - x        
#print 'MAksimalni loop: %s' % max(loop_sz)
#print 'Indeks elementa: %s' % loop_sz.index(max(loop_sz))
#print 'Broj ponavljanje: %s' % times_ex[loop_sz.index(max(loop_sz))]
print 'Cache size: %s' % size        
print 'Power consumption without cache: %s' % power_nocache        
print 'Power consumption with cache: %s' % power_withcache
print 'Power savings: %s ' % power_savings
                
with open('results_dijkstra.csv', 'wb') as result_file:    
    csv_writer = csv.writer(result_file)
    for row in range (1):
       csv_writer.writerow([instruction] + ['Total Valid Instructions'] )
       csv_writer.writerow([invalid] + ['Invalid Addresses:'])
       csv_writer.writerow([sram_writes] + ['SRAM Writes:'])
       csv_writer.writerow([sram_reads] + ['SRAM Reads:'])
       csv_writer.writerow([flash_reads] + ['Flash reads:'])
       csv_writer.writerow([' '])
       csv_writer.writerow(['Loop size:'] + loop_sz)
       csv_writer.writerow(['Times executed:'] + times_ex)
       csv_writer.writerow(['First:'] + firsts)
       csv_writer.writerow(['Sbb:'] + sbbs)
       csv_writer.writerow(['Last instruction of the loop (its row in dataset) read from SRAM:'] + inst_no)
       csv_writer.writerow([size] + ['Cache size'] )
       csv_writer.writerow([power_nocache] + ['Total Power With No Cache'] )
       csv_writer.writerow([power_withcache] + ['Total Power With Cache'] )
       csv_writer.writerow([power_savings] + ['Power Savings'] )
       csv_writer.writerow([hit_rate] + ['Hit Rate:'] )
       csv_writer.writerow([rw_ratio] + ['RW Ratio'] )
result_file.close()                
                    
                    
                    
      
           
           
          
    
      
  
  
  
  
  


